Bug 1819148 - Review Request: act - Automatic Component Toolkit
Summary: Review Request: act - Automatic Component Toolkit
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Dennis Gilmore
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1818945
TreeView+ depends on / blocked
 
Reported: 2020-03-31 10:25 UTC by Miro Hrončok
Modified: 2020-05-21 04:16 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-05-15 02:35:28 UTC
Type: ---
dgilmore: fedora-review+


Attachments (Terms of Use)

Description Miro Hrončok 2020-03-31 10:25:08 UTC
Spec URL: https://churchyard.fedorapeople.org/SRPMS/act.spec
SRPM URL: https://churchyard.fedorapeople.org/SRPMS/act-1.6.0-1.fc32.src.rpm

Description:
The Automatic Component Toolkit (ACT) is a code generator that takes an
instance of an Interface Description Language file and generates a thin
C89-API, implementation stubs and language bindings of your desired software
component.

Fedora Account System Username: churchyard

Note: I've tired to use as much gomagic macros as possible, but than I rolled back until it built on EPEL 7.

Comment 1 Weiping 2020-04-02 02:30:18 UTC
Hi,

this is an informal review:

> Name:           act
> %global lname   AutomaticComponentToolkit
It's not recommended to use lname, please follow name guideline:
https://docs.fedoraproject.org/en-US/packaging-guidelines/Naming/


> %{?gometa}
> %{?!gometa:BuildRequires: /usr/bin/go}
Packages MUST have BuildRequires: go-rpm-macros.
https://docs.fedoraproject.org/en-US/packaging-guidelines/Golang/#_dependencies



> mkdir -p %{buildroot}%{_bindir}
> install -m 0755 -vp act %{buildroot}%{_bindir}/

Better to use these macors:
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/
https://docs.fedoraproject.org/en-US/packaging-guidelines/Golang/#_binary_package_installation

Please add
%global golicenses      LICENSE.md
%global godocs          README.md



There is an example, for simple binary package:
https://docs.fedoraproject.org/en-US/packaging-guidelines/Golang/#_simple_binary_package


fedora-review failed to build this package:
+ GO111MODULE=off
+ go build -buildmode pie -compiler gc '-tags=rpm_crashtraceback ' -ldflags ' -B 0x4b072daa5c63e7865a65639d9d94578a8d195116 -extldflags '\''-Wl,-z,relro -Wl,--as-needed  -Wl,-z,now -specs=/usr/lib/rpm/redhat/redhat-hardened-ld '\''' -a -v -x -o act Source/actutils.go Source/automaticcomponenttoolkit.go Source/buildbindingccpp.go Source/buildbindingcsharp.go Source/buildbindinggo.go Source/buildbindingnode.go Source/buildbindingpascal.go Source/buildbindingpython.go Source/buildimplementationcpp.go Source/buildimplementationpascal.go Source/componentdefinition.go Source/componentdiff.go Source/languagec.go Source/languagecpp.go Source/languagepascal.go Source/languagewriter.go
WORK=/tmp/go-build362236170
runtime: mlock of signal stack failed: 12
runtime: increase the mlock limit (ulimit -l) or
runtime: update your kernel to 5.3.15+, 5.4.2+, or 5.5+
fatal error: mlock failed
runtime stack:
runtime.throw(0xa3b43e, 0xc)
        /usr/lib/golang/src/runtime/panic.go:1112 +0x72

Comment 2 Miro Hrončok 2020-04-02 06:55:06 UTC
(In reply to Weiping from comment #1)
> Hi,
> 
> this is an informal review:

Hello Weiping. Thanks for doing this.


> > Name:           act
> > %global lname   AutomaticComponentToolkit
> It's not recommended to use lname, please follow name guideline:
> https://docs.fedoraproject.org/en-US/packaging-guidelines/Naming/

I don't understand. There is not a single mention of lname in that guidelines. Nor it is said that it is not recommended.
The simple fact that it is not mentioned doesn't mean we should not do this.


> > %{?gometa}
> > %{?!gometa:BuildRequires: /usr/bin/go}
> Packages MUST have BuildRequires: go-rpm-macros.
> https://docs.fedoraproject.org/en-US/packaging-guidelines/Golang/
> #_dependencies


On Fedora, %gometa adds that.
On EPEL 7, there is no go-rpm-macros :(

> > mkdir -p %{buildroot}%{_bindir}
> > install -m 0755 -vp act %{buildroot}%{_bindir}/
> 
> Better to use these macors:
> install -m 0755 -vd                     %{buildroot}%{_bindir}
> install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/
> https://docs.fedoraproject.org/en-US/packaging-guidelines/Golang/
> #_binary_package_installation

I found that overcomplicated and I don't have %{gobuilddir} on EPEL 7.


> Please add
> %global golicenses      LICENSE.md
> %global godocs          README.md
> 
> 
> 
> There is an example, for simple binary package:
> https://docs.fedoraproject.org/en-US/packaging-guidelines/Golang/
> #_simple_binary_package

It is, but since I don't have the devel subpackage, I think this would only make the spec more complicated.


> fedora-review failed to build this package:
> + GO111MODULE=off
> + go build -buildmode pie -compiler gc '-tags=rpm_crashtraceback ' -ldflags
> ' -B 0x4b072daa5c63e7865a65639d9d94578a8d195116 -extldflags '\''-Wl,-z,relro
> -Wl,--as-needed  -Wl,-z,now -specs=/usr/lib/rpm/redhat/redhat-hardened-ld
> '\''' -a -v -x -o act Source/actutils.go Source/automaticcomponenttoolkit.go
> Source/buildbindingccpp.go Source/buildbindingcsharp.go
> Source/buildbindinggo.go Source/buildbindingnode.go
> Source/buildbindingpascal.go Source/buildbindingpython.go
> Source/buildimplementationcpp.go Source/buildimplementationpascal.go
> Source/componentdefinition.go Source/componentdiff.go Source/languagec.go
> Source/languagecpp.go Source/languagepascal.go Source/languagewriter.go
> WORK=/tmp/go-build362236170
> runtime: mlock of signal stack failed: 12
> runtime: increase the mlock limit (ulimit -l) or
> runtime: update your kernel to 5.3.15+, 5.4.2+, or 5.5+
> fatal error: mlock failed
> runtime stack:
> runtime.throw(0xa3b43e, 0xc)
>         /usr/lib/golang/src/runtime/panic.go:1112 +0x72


I can build the package just fine, see the copr builds. How are you using fedora-review?

Comment 3 Weiping 2020-04-06 12:43:43 UTC
(In reply to Miro Hrončok from comment #2)

> I can build the package just fine, see the copr builds. How are you using
> fedora-review?

fedora-review -u https://bugzilla.redhat.com/show_bug.cgi?id=1819148

See https://linux.die.net/man/1/fedora-review for more detail.

It seems a issue related kernel or complier, I try to enlarge limitation
of lock memory, but doesn't work.

Comment 4 Miro Hrončok 2020-04-06 12:51:32 UTC
Try adding:

   -m fedora-rawhide-x86_64

Comment 5 Dennis Gilmore 2020-05-05 13:43:35 UTC
Approved

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- If your application is a C or C++ application you must list a
  BuildRequires against gcc, gcc-c++ or clang.
  Note: No gcc, gcc-c++ or clang found in BuildRequires
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/C_and_C++/


===== MUST items =====

C/C++:
[ ]: Package does not contain kernel modules.
[ ]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[ ]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[ ]: Package contains systemd file(s) if in need.
[ ]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[ ]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[ ]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[ ]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[ ]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: act-1.6.0-1.fc30.x86_64.rpm
          act-debuginfo-1.6.0-1.fc30.x86_64.rpm
          act-debugsource-1.6.0-1.fc30.x86_64.rpm
          act-1.6.0-1.fc30.src.rpm
act.x86_64: W: no-manual-page-for-binary act
4 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (debuginfo)
-------------------
Checking: act-debuginfo-1.6.0-1.fc30.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
act-debuginfo.x86_64: W: invalid-url URL: https://github.com/Autodesk/AutomaticComponentToolkit <urlopen error [Errno -2] Name or service not known>
act-debugsource.x86_64: W: invalid-url URL: https://github.com/Autodesk/AutomaticComponentToolkit <urlopen error [Errno -2] Name or service not known>
act.x86_64: W: invalid-url URL: https://github.com/Autodesk/AutomaticComponentToolkit <urlopen error [Errno -2] Name or service not known>
act.x86_64: W: no-manual-page-for-binary act
3 packages and 0 specfiles checked; 0 errors, 4 warnings.



Source checksums
----------------
https://github.com/Autodesk/AutomaticComponentToolkit/archive/v1.6.0/AutomaticComponentToolkit-1.6.0.tar.gz :
  CHECKSUM(SHA256) this package     : 2d0337188246bb00d878ab5d0e30f3a97a4ec34bfcf82d76e17cb75dc38cad37
  CHECKSUM(SHA256) upstream package : 2d0337188246bb00d878ab5d0e30f3a97a4ec34bfcf82d76e17cb75dc38cad37


Requires
--------
act (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libpthread.so.0()(64bit)
    rtld(GNU_HASH)

act-debuginfo (rpmlib, GLIBC filtered):

act-debugsource (rpmlib, GLIBC filtered):



Provides
--------
act:
    act
    act(x86-64)

act-debuginfo:
    act-debuginfo
    act-debuginfo(x86-64)
    debuginfo(build-id)

act-debugsource:
    act-debugsource
    act-debugsource(x86-64)



Generated by fedora-review 0.7.5 (5fa5b7e) last change: 2020-02-16
Command line :/usr/bin/fedora-review -b 1819148
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, C/C++, Shell-api
Disabled plugins: Python, PHP, Haskell, Java, fonts, Ocaml, Perl, R, SugarActivity
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 6 Gwyn Ciesla 2020-05-05 14:30:49 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/act

Comment 7 Fedora Update System 2020-05-05 16:46:39 UTC
FEDORA-EPEL-2020-6ecb9adca3 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2020-6ecb9adca3

Comment 8 Fedora Update System 2020-05-05 18:48:41 UTC
FEDORA-EPEL-2020-6ecb9adca3 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2020-6ecb9adca3

Comment 9 Fedora Update System 2020-05-05 20:12:11 UTC
FEDORA-2020-6e5fe0249d has been submitted as an update to Fedora 32. https://bodhi.fedoraproject.org/updates/FEDORA-2020-6e5fe0249d

Comment 10 Fedora Update System 2020-05-06 06:16:04 UTC
FEDORA-EPEL-2020-6ecb9adca3 has been pushed to the Fedora EPEL 7 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2020-6ecb9adca3

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 11 Fedora Update System 2020-05-07 05:20:46 UTC
FEDORA-2020-6e5fe0249d has been pushed to the Fedora 32 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-6e5fe0249d \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-6e5fe0249d

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 12 Fedora Update System 2020-05-15 02:35:28 UTC
FEDORA-2020-6e5fe0249d has been pushed to the Fedora 32 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 13 Fedora Update System 2020-05-21 04:16:18 UTC
FEDORA-EPEL-2020-6ecb9adca3 has been pushed to the Fedora EPEL 7 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.